var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

import { LuckyWheel } from 'lucky-canvas';
import { changeUnits, resolveImage } from '../utils/index.js';

Component({
  data: {
    isShow: false
  },
  didMount: function didMount() {
    var _this = this;

    my.createSelectorQuery()['in'](this).select('#lucky-wheel').node(function (res) {
      var canvas = _this.canvas = res.node; //res[0].node
      var dpr = _this.dpr = my.getSystemInfoSync().pixelRatio;
      var ctx = _this.ctx = canvas.getContext('2d');
      var data = _this.props;
      canvas.width = canvas.width * dpr;
      canvas.height = canvas.height * dpr;
      // ctx.scale(dpr, dpr)
      _this.$lucky = new LuckyWheel({
        flag: 'MP-WX',
        ctx: ctx,
        dpr: dpr,
        width: canvas.width,
        height: canvas.height,
        // rAF: canvas.requestAnimationFrame, // 帧动画真机调试会报错!
        setTimeout: setTimeout,
        clearTimeout: clearTimeout,
        setInterval: setInterval,
        clearInterval: clearInterval,
        beforeCreate: function beforeCreate() {
          var Radius = Math.min(this.config.width, this.config.height) / 2;
          // 设置坐标轴
          ctx.translate(Radius, Radius);
        },
        beforeInit: function beforeInit() {
          // 重置坐标轴
          ctx.translate(-this.Radius, -this.Radius);
        },
        afterInit: function afterInit() {},

        unitFunc: function unitFunc(num, unit) {
          return changeUnits(num + unit);
        }
      }, _extends({}, data, {
        start: function start() {
          var _props;

          (_props = _this.props).onStart.apply(_props, arguments);
        },
        end: function end() {
          var _props2;

          (_props2 = _this.props).onEnd.apply(_props2, arguments);
        }
      }));
      _this.setData({
        isShow: true
      });
    }).exec();
  },

  methods: {
    imgBindload: function imgBindload(e) {
      var _e$currentTarget$data = e.currentTarget.dataset,
          name = _e$currentTarget$data.name,
          index = _e$currentTarget$data.index,
          i = _e$currentTarget$data.i;

      var img = this.props[name][index].imgs[i];
      resolveImage(e, img, this.canvas);
    },
    toPlay: function toPlay(e) {
      var ctx = this.ctx;
      var _e$changedTouches$ = e.changedTouches[0],
          x = _e$changedTouches$.clientX,
          y = _e$changedTouches$.clientY;

      ctx.beginPath();
      ctx.arc(0, 0, this.$lucky.maxBtnRadius, 0, Math.PI * 2, false);
      if (!ctx.isPointInPath(x * this.dpr, y * this.dpr)) return;
      this.$lucky.startCallback();
    },
    play: function play() {
      var _$lucky;

      (_$lucky = this.$lucky).play.apply(_$lucky, arguments);
    },
    stop: function stop() {
      var _$lucky2;

      (_$lucky2 = this.$lucky).stop.apply(_$lucky2, arguments);
    }
  }
});