var windowWidth = my.getSystemInfoSync().windowWidth;

export var rpx2px = function rpx2px(value) {
  if (typeof value === 'string') value = Number(value.replace(/[a-z]*/g, ''));
  return windowWidth / 750 * value;
};

export var changeUnits = function changeUnits(value) {
  return Number(value.replace(/^(\-*[0-9.]*)([a-z%]*)$/, function (value, num, unit) {
    switch (unit) {
      case 'px':
        num *= 1;
        break;
      case 'rpx':
        num = rpx2px(num);
        break;
      default:
        num *= 1;
        break;
    }
    return num;
  }));
};

export var resolveImage = function resolveImage(e, img, canvas) {
  var srcName = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 'src';
  var resolveName = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : '$resolve';

  var imgObj = canvas.createImage();
  imgObj.onload = function () {
    img[resolveName](imgObj);
  };
  imgObj.src = img[srcName];
};